%define 	pname httpd-iworx
%define		rname httpd
%define 	pversion 2.4.46
%define 	bversion 10
%define 	rpmrelease iworx

# Adding httpd-mmn package, since building iworx-php needs it.
# The value here is taken from the httpd-2.2 spec file
%define mmn 20051115

%define 	debug_package %{nil}

# INSTRUCTIONS!!! <--------------------- READ THEM!!!
#
# You can rebuild  this  package safely using Command
# Line Overrides. For example, if you want to rebuild
# this package for RedHat just type:
# $ rpm --rebuild --with redhat package.src.rpm
# $ rpm -ba --with redhat package.spec
#
# mdk = GNU/Linux Mandrake
# rht = Linux Red-Hat
# sus = Suse Linux
# fdr = Fedora Linux
# cos = CentOS
# whb = White Box Linux
# rhe = Red Hat Enterprise
# unk = Unknown
#
%define		build_rhe_7x   0
%define		build_rhe_8x   0

%define		build_unk      1

# Command Line Overrides
%{?_with_rhe7x: 	%{expand: %%define build_rhe_7x   1}}
%{?_with_rhe8x: 	%{expand: %%define build_rhe_8x   1}}

%{?_with_unk: 		%{expand: %%define build_unk      1}}

%if %{build_rhe_7x}
%define		oscode rhe7x
%define 	ostype RedHat Enterprise 7.x
BuildRequires:	pcre-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
BuildRequires:	libtool
BuildRequires:	openssl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_8x}
%define		oscode rhe8x
%define 	ostype Almalinux 8.x
BuildRequires:	pcre-devel
BuildRequires:	expat-devel
BuildRequires:	findutils
BuildRequires:	perl
BuildRequires:	pkgconfig
BuildRequires:	libtool
BuildRequires:	openssl-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%define release %{bversion}.%{oscode}.%{rpmrelease}

##
# THIS MUST BE LAST
##

%if %{build_unk}
%define		oscode unk
%define 	ostype Unknown Distribution
%define 	release %{bversion}.%{rpmrelease}
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%endif

############### RPM ################################

Summary: 	Apache HTTP Server (InterWorx)
Name: 		%{pname}
Version: 	%{pversion}
Release: 	%{release}
License: 	Apache License, Version 2.0

Group: 		System Environment/Daemons
Source0:	%{rname}-%{version}.tar.gz
URL: 		http://httpd.apache.org/

Distribution:	InterWorx-HAL
Vendor:         INTERWORX L.L.C.
Packager:       Tim College <tcollege@interworx.com>

BuildRoot:	%{_tmppath}/%{rname}-%{version}-root

Requires: 	iworxphp72
Requires:       perl
Provides:       iworx-httpd-mmn = %{mmn}
#Requires:       iworx-mod_fastcgi

BuildRequires: autoconf, perl, pkgconfig, findutils, xmlto
BuildRequires: zlib-devel, libselinux-devel, lua-devel
BuildRequires: apr-devel >= 1.5.2, apr-util-devel >= 1.2.0, pcre-devel >= 5.0
BuildRequires: systemd-devel
Requires: /etc/mime.types, system-logos >= 7.92.1-1
#Requires: iworx-httpd-tools = %{version}-%{release}
Requires: apr >= 1.5.2
Requires(pre): /usr/sbin/useradd
Requires(preun): systemd-units
Requires(postun): systemd-units
Requires(post): systemd-units

Source202:      httpd-iworx-mime.types
Source203:      httpd-iworx-iworx.conf
Source204:      httpd-iworx-httpd-custom.conf
Source205:      httpd-iworx-httpd-last.conf
Source206:      httpd-iworx-httpd-24.conf

Source110:       10-db-phpmyadmin.conf
Source111:       10-webmail-horde.conf
Source112:       10-webmail-roundcube.conf
Source113:       10-webmail-squirrelmail.conf

# Patches
# build/scripts patches
Patch1: httpd-2.4.1-apctl.patch
Patch2: httpd-2.4.25-apxs.patch
Patch3: httpd-2.4.1-deplibs.patch
Patch5: httpd-2.4.43-layout.patch
Patch6: httpd-2.4.3-apctl-systemd.patch
Patch7: httpd-2.4.12-skiplist.patch
#Patch8: httpd-2.4.25-detect-systemd.patch
# Features/functional changes
Patch24: httpd-2.4.1-corelimit.patch
Patch25: httpd-2.4.25-selinux.patch
Patch27: httpd-2.4.2-icons.patch

Patch30: httpd-2.4.4-cachehardmax.patch

Patch65: httpd-2.4.17-autoindex-revert.patch

# Security fixes

Patch300: suexec.patch
Patch301: harden-symlinks.patch
Patch303: httpd-2.4.46-huge-string-len-64k.patch


%description
Apache is a powerful, full-featured, efficient, and freely-available
Web server. Apache is also the most popular Web server on the
Internet.

%prep

%setup -q -n %{rname}-%{version}

# Apply patches

%global _default_patch_fuzz 2

%patch1 -p1 -b .apctl
%patch2 -p1 -b .apxs
%patch3 -p1 -b .deplibs
%patch5 -p0 -b .layout

%patch6 -p1 -b .apctlsystemd
%patch7 -p1 -b .skiplist

%patch24 -p1 -b .corelimit
%patch25 -p1 -b .selinux
%patch27 -p1 -b .icons

%patch30 -p1 -b .cachehardmax
%patch65 -p1 -b .autoindexrevert

%patch300 -p1
%patch301 -p1
%patch303 -p1


# Try detecting newest gcc (some distributions have got more then one compiler)
[ -f %{_tmppath}/%{rname}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{rname}-%{pversion}-gcc

if   [ -x /usr/bin/gcc-3.2.3 ]; then
	echo "/usr/bin/gcc-3.2.3" > %{_tmppath}/%{rname}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.2 ]; then
	echo "/usr/bin/gcc-3.2.2" > %{_tmppath}/%{rname}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.1 ]; then
	echo "/usr/bin/gcc-3.2.1" > %{_tmppath}/%{rname}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.2 ]; then
        echo "/usr/bin/gcc-3.2" > %{_tmppath}/%{rname}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.1.1 ]; then
        echo "/usr/bin/gcc-3.1.1" > %{_tmppath}/%{rname}-%{pversion}-gcc
else
	echo "gcc" > %{_tmppath}/%{rname}-%{pversion}-gcc
fi

# Display compilation flags and OS with nice colors
[ -f %{_tmppath}/%{rname}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{rname}-%{pversion}-show_flags
cat <<EOF >>%{_tmppath}/%{rname}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{rname}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 3

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{rname}-%{pversion}-show_flags
%{_tmppath}/%{rname}-%{pversion}-show_flags
[ -f %{_tmppath}/%{rname}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{rname}-%{pversion}-show_flags

# regenerate configure scripts
#./buildconf

%build

if pkg-config openssl ; then
	# configure -C barfs with trailing spaces in CFLAGS
	CFLAGS="$RPM_OPT_FLAGS `pkg-config --cflags openssl | sed 's/ *$//'`"
	AP_LIBS="$AP_LIBS `pkg-config --libs openssl`"
else
	CFLAGS="$RPM_OPT_FLAGS"
	AP_LIBS="-lssl -lcrypto"
fi
export CFLAGS
export AP_LIBS

function mpmbuild()
{
mpm=$1; shift
mkdir $mpm; pushd $mpm
cat > config.cache <<EOF
ac_cv_func_pthread_mutexattr_setpshared=no
ac_cv_func_sem_open=no
EOF
  ../configure 	-C \
	--prefix=%{_iworx_dir_sysconf}/httpd \
	--exec-prefix=%{_iworx_dir} \
 	--bindir=%{_iworx_dir_bin}/httpd \
 	--sbindir=%{_iworx_dir_bin}/httpd \
 	--mandir=/TODELETE \
	--libdir=%{_iworx_dir_lib}/httpd \
	--sysconfdir=%{_iworx_dir_sysconf}/httpd/conf \
	--includedir=%{_iworx_dir}/include/httpd \
	--libexecdir=%{_iworx_dir_lib}/httpd/modules \
	--with-mpm=$mpm \
        --with-devrandom=/dev/urandom \
	--with-ssl \
	--enable-ssl \
	--enable-so \
	--enable-deflate \
	$*

  %{__make} %{?_smp_mflags}
  popd
}

# Only bother enabling optional modules for main build.
mpmbuild prefork --enable-mods-shared=all

# To prevent most modules being built statically into httpd.worker,
# easiest way seems to be enable them shared.

%install

rm -rf %{buildroot}

pushd prefork
make DESTDIR=%{buildroot} install
popd

rm -rf %{buildroot}/TODELETE
rm -rf %{buildroot}%{_iworx_dir_sysconf}/httpd/cgi-bin
rm -rf %{buildroot}%{_iworx_dir_sysconf}/httpd/htdocs
rm -rf %{buildroot}%{_iworx_dir_sysconf}/httpd/error
rm -rf %{buildroot}%{_iworx_dir_sysconf}/httpd/icons
rm -rf %{buildroot}%{_iworx_dir_sysconf}/httpd/logs
rm -rf %{buildroot}%{_iworx_dir_sysconf}/httpd/manual
rm -rf %{buildroot}%{_iworx_dir_sysconf}/httpd/conf

mkdir -p -m0711 %{buildroot}%{_iworx_dir_sysconf}/httpd/conf.d/iworx-apps

install -m0600 %{SOURCE110} %{buildroot}%{_iworx_dir_sysconf}/httpd/conf.d/iworx-apps/10-db-phpmyadmin.conf
install -m0600 %{SOURCE111} %{buildroot}%{_iworx_dir_sysconf}/httpd/conf.d/iworx-apps/10-webmail-horde.conf
install -m0600 %{SOURCE112} %{buildroot}%{_iworx_dir_sysconf}/httpd/conf.d/iworx-apps/10-webmail-roundcube.conf
install -m0600 %{SOURCE113} %{buildroot}%{_iworx_dir_sysconf}/httpd/conf.d/iworx-apps/10-webmail-squirrelmail.conf

install -m0600 %{SOURCE206} %{buildroot}%{_iworx_dir_sysconf}/httpd/httpd.conf
install -m0600 %{SOURCE204} %{buildroot}%{_iworx_dir_sysconf}/httpd/httpd-custom.conf
install -m0600 %{SOURCE204} %{buildroot}%{_iworx_dir_sysconf}/httpd/httpd-custom-new.conf
install -m0600 %{SOURCE205} %{buildroot}%{_iworx_dir_sysconf}/httpd/httpd-last.conf
install -m0600 %{SOURCE202} %{buildroot}%{_iworx_dir_sysconf}/httpd/mime.types

mkdir -p -m0755 %{buildroot}%{_sysconfdir}/httpd/conf.d
install -m0644 %{SOURCE203} %{buildroot}%{_sysconfdir}/httpd/conf.d/iworx.conf

# Make the MMN accessible to module packages
echo %{mmn} > %{buildroot}%{_iworx_dir_sysconf}/httpd/.mmn

%post

ln -fs %{_iworx_dir_bin}/httpd/httpd %{_iworx_dir_bin}/iworx-web

#
# only if we're upgrading
if [ "$1" = "2" ]; then
	if [ -f %{_sysconfdir}/init.d/iworx ]; then
		grep %{_iworx_dir_sysconf}/httpd/httpd-last.conf %{_iworx_dir_sysconf}/httpd/httpd-custom.conf > /dev/null
		if [ "$?" = "1" ]; then
			cp %{_iworx_dir_sysconf}/httpd/httpd-custom-new.conf %{_iworx_dir_sysconf}/httpd/httpd-custom.conf
			%{_sysconfdir}/init.d/iworx restartweb
		fi
	fi
	sed -i 's/HIGH:MEDIUM:!SSLv2:!ADH:!aNULL:!eNULL:!NULL:!LOW$/HIGH:MEDIUM:!SSLv2:!ADH:!aNULL:!eNULL:!NULL:!LOW:!EXP/' %{_iworx_dir_sysconf}/httpd/httpd-custom.conf

  # erase the webmail config from the httpd-custom.conf (it's in conf.d/iworx-apps now)
	perl -0777 -pi -e 's/##\n# Horde.*(##\n# AWStats)/\1/s' %{_iworx_dir_sysconf}/httpd/httpd-custom.conf

	if [ -f /etc/httpd/conf.d/iworx.conf ]; then
            grep -q /usr/local/interworx/bin/iw-bw-logger /etc/httpd/conf.d/iworx.conf ||
		cat <<EOF >> /etc/httpd/conf.d/iworx.conf

<IfModule !mod_version.c>
  LoadModule version_module modules/mod_version.so
</IfModule>

<IfModule !mod_logio.c>
  LoadModule logio_module modules/mod_logio.so
</IfModule>

<IfModule !mod_watch.c>
  LogFormat "%v %I %O" iworxio
  <IfVersion >= 2.4>
    GlobalLog "|/usr/local/interworx/bin/iw-bw-logger" iworxio
  </IfVersion>
</IfModule>

EOF

	fi
	touch /home/interworx/var/run/restart-web
fi

%preun
if [ "$1" == "0" ]; then
   echo
   echo "WARNING: httpd-iworx package removal request denied.  This package is required by Interworx."
   echo
   exit 1
fi

%postun

#
# only if we're erasing
if [ "$1" = "0" ]; then
        [ -L %{_iworx_dir_bin}/iworx-web ] && rm -f %{_iworx_dir_bin}/iworx-web
fi

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
[ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion} || :

%pre
# make the iworx group (if needed)
/bin/grep "^%{_iworx_group}:" /etc/group >/dev/null || groupadd -r %{_iworx_group} -g ${_iworx_gid}

# make the vchkpw group (if needed)
/bin/grep "vchkpw:" /etc/group > /dev/null || groupadd -r -g 104 vchkpw

# make the iworx  user (if needed)
/bin/grep "^%{_iworx_user}:" /etc/passwd >/dev/null || /usr/sbin/useradd \
	-u %{_iworx_uid} -g %{_iworx_group} -G vchkpw -d %{_iworx_dir} \
	-s /bin/bash -c %{name} -r -m %{_iworx_user}

# make the iworx-web group (if needed)
/bin/grep "^%{_iworx_web_group}:" /etc/group >/dev/null || groupadd -r %{_iworx_web_group}

# make the iworx-web user (if needed)
/bin/grep "^%{_iworx_web_user}:" /etc/passwd >/dev/null || /usr/sbin/useradd \
	-g %{_iworx_web_group} -d / \
	-s /sbin/nologin -c %{name} -r %{_iworx_web_user}

%files
%defattr(-,%{_iworx_user},%{_iworx_group})
%attr(0711,%{_iworx_user},%{_iworx_group}) %dir %{_iworx_dir_bin}/httpd
%attr(0755,%{_iworx_user},%{_iworx_group}) %{_iworx_dir_bin}/httpd/*
%attr(0711,%{_iworx_user},%{_iworx_group}) %dir %{_iworx_dir_sysconf}/httpd
%attr(0755,%{_iworx_user},%{_iworx_group}) %{_iworx_dir_sysconf}/*
%attr(0711,%{_iworx_user},%{_iworx_group}) %dir %{_iworx_dir}/include/httpd
%attr(0644,%{_iworx_user},%{_iworx_group}) %{_iworx_dir}/include/httpd/*
%attr(0711,%{_iworx_user},%{_iworx_group}) %dir %{_iworx_dir_lib}/httpd
%attr(0644,%{_iworx_user},%{_iworx_group}) %{_iworx_dir_lib}/httpd/*
%config(noreplace) %attr(0600,%{_iworx_user},%{_iworx_group}) %{_iworx_dir_sysconf}/httpd/httpd-custom.conf
%config(noreplace) %attr(0644,%{_iworx_user},%{_iworx_group}) %{_sysconfdir}/httpd/conf.d/iworx.conf
%attr(0711,%{_iworx_user},%{_iworx_group}) %dir %{_iworx_dir_sysconf}/httpd/conf.d
%attr(0711,%{_iworx_user},%{_iworx_group}) %dir %{_iworx_dir_sysconf}/httpd/conf.d/iworx-apps
%attr(0600,%{_iworx_user},%{_iworx_group}) %{_iworx_dir_sysconf}/httpd/conf.d/iworx-apps/*


%changelog
* Mon Oct 04 2021 Tim College <tcollege@interworx.com>
- Upgrade to 2.4.46
